﻿<template>
    <form class="form"
          novalidate
          @submit.prevent="handleSubmit"
          enctype="multipart/form-data">
        <FormRow>
            <FormInput v-model="waitingMember.firstName"
                       type="text"
                       name="firstName"
                       :ref="addFormInputRef"
                       :label="t('waitingMember.firstName')"
                       @validated="handleValidation" />
            <FormInput v-model="waitingMember.lastName"
                       type="text"
                       name="lastName"
                       :ref="addFormInputRef"
                       :label="t('waitingMember.lastName')"
                       @validated="handleValidation" />
        </FormRow>
        <FormInput v-model="waitingMember.adress"
                   type="text"
                   name="adress"
                   :ref="addFormInputRef"
                   :label="t('waitingMember.adress')"
                   @validated="handleValidation"/>
        <FormRow>
            <FormInput v-model="waitingMember.appNb"
                       type="number"
                       name="appNb"
                       :ref="addFormInputRef"
                       :label="t('waitingMember.appNb')"
                       :rules="[]"
                       @validated="handleValidation" />
            <FormInput v-model="waitingMember.postalCode"
                       type="text"
                       name="postalCode"
                       :ref="addFormInputRef"
                       :label="t('waitingMember.postalCode')"
                       @validated="handleValidation" />
        </FormRow>
        <FormRow>
            <FormInput v-model="waitingMember.email"
                       type="email"
                       name="email"
                       :ref="addFormInputRef"
                       :label="t('waitingMember.email')"
                       @validated="handleValidation" />
            <FormInput v-model="waitingMember.phoneNumber"
                       type="text"
                       name="phoneNumber"
                       placeholder="4181234567"
                       :ref="addFormInputRef"
                       :label="t('waitingMember.phoneNumber')"
                       @validated="handleValidation" />
        </FormRow>
        <FormRow>
            <FormRadios
                        v-model="waitingMember.from"
                        title="Je suis avec"
                        name="from"
                        :options="radioOptions"
                        required="True"
                        />
            <FormSelect
                        v-model="selectedLot"
                        name="lotSelect"
                        :options="lotOptions"
                        :label="t('lot.lotNumber')"
                        required="true"/>
        </FormRow>

    <button class="form__submit btn btn--fullscreen" type="submit">
        {{ t("global.add") }}
    </button>
    </form>
</template>

<script lang="ts" setup>
    import FormRow from "@/components/forms/FormRow.vue"
    import FormInput from "@/components/forms/FormInput.vue"
    import FormRadios from "@/components/forms/FormRadios.vue"
    import FormSelect from "@/components/forms/FormSelect.vue"
    import ProductBaseForm from "@/components/products/ProductBaseForm.vue"
    import { computed, onMounted, ref } from "vue"
    import { useLotService } from "@/inversify.config";
    import { useI18n } from "vue3-i18n"
    import { notifyError } from "@/notify"
    import { Status } from "@/validation"
    import { FormOption } from "@/types/formOption"
    import { WaitingMember } from "@/types/entities/waitingMember"
    import { Lot } from "@/types/entities";
import { Guid } from "../../types"

    // eslint-disable-next-line no-undef
    const props = defineProps<{
        waitingMember?: WaitingMember
    }>()

    // eslint-disable-next-line
    const emit = defineEmits<{
        (event: "formSubmit", waitingMember: WaitingMember, lot: Lot): void
    }>()

    const { t } = useI18n()
    const lotService = useLotService()

    const emptyLots = ref<Lot[]>();

    const lotOptions = computed(() => {
        return emptyLots.value ? emptyLots.value.map((lot: Lot) => ({
            name:lot,
            label: `Lot ${lot.lotNumber}`
        })) : []
    });

    onMounted(async () => {
        console.log("Mise a jour empty lots")
        await loadAllEmptyLots();
    });

    const waitingMember = ref<WaitingMember>(props.waitingMember ?? {})
    waitingMember.value.from = "cegep"
    const radioOptions: FormOption[] = [{ name: "cegep", label: "Le Cégep Garneau" }, { name: "loisirs", label: "Les loisirs Saint-Sacrement" }]
    const formInputs = ref<any[]>([])
    const inputValidationStatuses: any = {}
    const selectedLot = ref<Lot | null>(null);

    function addFormInputRef(ref: typeof FormInput) {
        if (!formInputs.value.includes(ref) && ref)
            formInputs.value.push(ref)
    }

    async function handleValidation(name: string, validationStatus: Status) {
        inputValidationStatuses[name] = validationStatus.valid
    }

    async function handleSubmit() {
        console.log("MemberForm : " + selectedLot.value)
        formInputs.value.forEach((x: typeof FormInput) => x.validateInput())
        if (Object.values(inputValidationStatuses).some(x => x === false)) {
            notifyError(t('global.formErrorNotification'))
            return
        }
        if (selectedLot.value) {
            emit("formSubmit", waitingMember.value, selectedLot.value)
        } else {
            notifyError(t('global.formErrorNotification'))
            return
        }
        
    }

    async function loadAllEmptyLots() {
        let lots = await lotService.getLotsEmptyCurrentYear();
        if (lots && lots.length > 0) {
            emptyLots.value = lots;
        }
        console.log(lots)
    }
</script>